Package org.zkoss.xel.zel

## Class ELXelExpression

- java.lang.Object
- - org.zkoss.xel.zel.ELXelExpression

- All Implemented Interfaces:
    `java.io.Serializable`, `Expression`, `ExpressionX`
  Direct Known Subclasses:
    `BindXelExpression`

      public class ELXelExpression
      extends java.lang.Object
      implements ExpressionX, java.io.Serializable

  An XEL Expression that is based on ZEL ValueExpression.
  Since:
    6.0.0
  Author:
    henrichen
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `ELXelExpression.ValueReferenceImpl` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ValueExpression` | `_expr` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ELXelExpression​(ValueExpression expr)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Object` | `evaluate​(XelContext xelc)` | Evaluates an expression that was previously prepared.
    `java.lang.String` | `getExpressionString()` | Returns the expression in String form.
    `java.lang.Class` | `getType​(XelContext xelc)` | Returns the result type of this expression.
    `ValueReference` | `getValueReference​(XelContext xelc)` | Returns the target bean and field name of this expression.
    `boolean` | `isReadOnly​(XelContext xelc)` | Returns whether this is a read only (cannot setValue) expression.
    `protected ELContext` | `newELContext​(XelContext xelc)` |
    `void` | `setValue​(XelContext xelc, java.lang.Object value)` | Set values into the property resolved by this expression.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _expr

          protected final ValueExpression _expr

  - ### Constructor Detail

    - #### ELXelExpression

          public ELXelExpression​(ValueExpression expr)

  - ### Method Detail

    - #### evaluate

          public java.lang.Object evaluate​(XelContext xelc)
                                    throws XelException

      Description copied from interface: `Expression`
      Evaluates an expression that was previously prepared.
      Specified by:
        `evaluate` in interface `Expression`
      Throws:
        `XelException`

    - #### isReadOnly

          public boolean isReadOnly​(XelContext xelc)
                             throws XelException

      Description copied from interface: `ExpressionX`
      Returns whether this is a read only (cannot setValue) expression.
      Specified by:
        `isReadOnly` in interface `ExpressionX`
      Parameters:
        `xelc` - the evaluation context
      Returns:
        whether this is a read only (cannot setValue) expression.
      Throws:
        `XelException`

    - #### setValue

          public void setValue​(XelContext xelc,
                               java.lang.Object value)
                        throws XelException

      Description copied from interface: `ExpressionX`
      Set values into the property resolved by this expression.
      Specified by:
        `setValue` in interface `ExpressionX`
      Parameters:
        `xelc` - the evaluation context
        `value` - the value to be set into the property resolved by this expression
      Throws:
        `XelException`

    - #### getExpressionString

          public java.lang.String getExpressionString()

      Description copied from interface: `ExpressionX`
      Returns the expression in String form.
      Specified by:
        `getExpressionString` in interface `ExpressionX`
      Returns:
        the expression in String form.

    - #### getType

          public java.lang.Class getType​(XelContext xelc)

      Description copied from interface: `ExpressionX`
      Returns the result type of this expression.
      Specified by:
        `getType` in interface `ExpressionX`
      Parameters:
        `xelc` - the evaluation context
      Returns:
        the result type of this expression.

    - #### getValueReference

          public ValueReference getValueReference​(XelContext xelc)

      Description copied from interface: `ExpressionX`
      Returns the target bean and field name of this expression.
      Specified by:
        `getValueReference` in interface `ExpressionX`
      Parameters:
        `xelc` - the evaluation context
      Returns:
        the target bean and field name of this expression.

    - #### newELContext

          protected ELContext newELContext​(XelContext xelc)